--- //depot/vendor/freebsd/src/sys/net/if_sl.c	2005/06/10 16:51:34
+++ //depot/user/rwatson/netperf/sys/net/if_sl.c	2005/07/05 14:55:33
@@ -162,6 +162,7 @@
 #define	ABT_WINDOW	(ABT_COUNT*2+2)	/* in seconds - time to count */
 
 static LIST_HEAD(sl_list, sl_softc) sl_list;
+static struct mtx slip_mtx;
 
 #define FRAME_END	 	0xc0		/* Frame End */
 #define FRAME_ESCAPE		0xdb		/* Frame Esc */
@@ -204,6 +205,7 @@
 { 
 	switch (type) { 
 	case MOD_LOAD: 
+		mtx_init(&slip_mtx, "slip_mtx", NULL, MTX_DEF);
 		ldisc_register(SLIPDISC, &slipdisc);
 		LIST_INIT(&sl_list);
 		break; 
@@ -225,6 +227,7 @@
 
 DECLARE_MODULE(if_sl, sl_mod, SI_SUB_PSEUDO, SI_ORDER_ANY);
 
+/* Locked using slip_mtx. */
 static int *st_unit_list;
 static size_t st_unit_max = 0;
 
@@ -233,6 +236,7 @@
 {
 	struct sl_softc *sc;
 
+	mtx_assert(&slip_mtx, MA_OWNED);
 	LIST_FOREACH(sc, &sl_list, sl_next) {
 		if (SL2IFP(sc)->if_dunit == unit)
 			return (0);
@@ -256,6 +260,7 @@
 {
 	size_t i;
 
+	mtx_assert(&slip_mtx, MA_OWNED);
 	for (i = 0; i < st_unit_max; i++)
 		if (st_unit_list[i] == unit)
 			return 1;
@@ -267,6 +272,7 @@
 {
 	int *t;
 
+	mtx_assert(&slip_mtx, MA_OWNED);
 	if (slisstatic(unit))
 		return;
 
@@ -334,10 +340,12 @@
 	SL2IFP(sc)->if_linkmib = sc;
 	SL2IFP(sc)->if_linkmiblen = sizeof *sc;
 	mtx_init(&sc->sc_fastq.ifq_mtx, "sl_fastq", NULL, MTX_DEF);
+	mtx_init(&sc->sc_mtx, "slip sc_mtx", NULL, MTX_DEF);
 
 	/*
 	 * Find a suitable unit number.
 	 */
+	mtx_lock(&slip_mtx);
 	for (unit=0; ; unit++) {
 		if (slisstatic(unit))
 			continue;
@@ -347,6 +355,7 @@
 	}
 	if_initname(SL2IFP(sc), "sl", unit);
 	LIST_INSERT_HEAD(&sl_list, sc, sl_next);
+	mtx_unlock(&slip_mtx);
 
 	if_attach(SL2IFP(sc));
 	bpfattach(SL2IFP(sc), DLT_SLIP, SLIP_HDRLEN);
@@ -403,11 +412,21 @@
 static void
 sldestroy(struct sl_softc *sc)
 {
+
+	/*
+	 * XXXRW: Slight race here: we may detach bpf/if before we
+	 * attach.  This appears to be a property of the unit selection
+	 * process, which might be better handled by the interface
+	 * cloning subsystem?
+	 */
 	bpfdetach(SL2IFP(sc));
 	if_detach(SL2IFP(sc));
 	if_free(SL2IFP(sc));
+	mtx_lock(&slip_mtx);
 	LIST_REMOVE(sc, sl_next);
+	mtx_unlock(&slip_mtx);
 	m_free(sc->sc_mbuf);
+	mtx_destroy(&sc->sc_mtx);
 	mtx_destroy(&sc->sc_fastq.ifq_mtx);
 	if (sc->bpfbuf)
 		free(sc->bpfbuf, M_SL);
@@ -434,6 +453,10 @@
 	clist_free_cblocks(&tp->t_outq);
 	sc = sl_for_tty(tp);
 	if (sc != NULL) {
+		/*
+		 * XXXRW: tear-down race between timeout and slclose()?
+		 */
+		mtx_lock(&sc->sc_mtx);
 		if (sc->sc_outfill) {
 			sc->sc_outfill = 0;
 			untimeout(sl_outfill, sc, sc->sc_ofhandle);
@@ -442,6 +465,7 @@
 			sc->sc_keepalive = 0;
 			untimeout(sl_keepalive, sc, sc->sc_kahandle);
 		}
+		mtx_unlock(&sc->sc_mtx);
 		if_down(SL2IFP(sc));
 		sc->sc_ttyp = NULL;
 		sldestroy(sc);
@@ -474,12 +498,21 @@
 			splx(s);
 			return (ENXIO);
 		}
+		/*
+		 * XXXRW: we hold the mutex over all of this to protect
+		 * the unit change and global list consistency.  However,
+		 * some of these functions probably sleep, making this
+		 * wrong.  If we have to support renumbering, we probably
+		 * need a way to reserve both numbers to prevent them
+		 * from being reused during the change, or a way to sleep
+		 * waiting for a change to end (i.e., a CV).
+		 */
+		mtx_lock(&slip_mtx);
 		if (SL2IFP(sc)->if_dunit != unit) {
 			if (!slisunitfree(unit)) {
-				splx(s);
+				mtx_unlock(&slip_mtx);
 				return (ENXIO);
 			}
-
 			wasup = SL2IFP(sc)->if_flags & IFF_UP;
 			bpfdetach(SL2IFP(sc));
 			if_detach(SL2IFP(sc));
@@ -497,9 +530,11 @@
 			    SLIP_HIWAT + 2 * SL2IFP(sc)->if_mtu + 1);
 		}
 		slmarkstatic(unit);
+		mtx_unlock(&slip_mtx);
 		break;
 
 	case SLIOCSKEEPAL:
+		mtx_lock(&sc->sc_mtx);
 		sc->sc_keepalive = *(u_int *)data * hz;
 		if (sc->sc_keepalive) {
 			sc->sc_flags |= SC_KEEPALIVE;
@@ -511,6 +546,7 @@
 				sc->sc_flags &= ~SC_KEEPALIVE;
 			}
 		}
+		mtx_unlock(&sc->sc_mtx);
 		break;
 
 	case SLIOCGKEEPAL:
@@ -518,6 +554,7 @@
 		break;
 
 	case SLIOCSOUTFILL:
+		mtx_lock(&sc->sc_mtx);
 		sc->sc_outfill = *(u_int *)data * hz;
 		if (sc->sc_outfill) {
 			sc->sc_flags |= SC_OUTWAIT;
@@ -529,9 +566,11 @@
 				sc->sc_flags &= ~SC_OUTWAIT;
 			}
 		}
+		mtx_unlock(&sc->sc_mtx);
 		break;
 
 	case SLIOCGOUTFILL:
+		/* Unlocked read. */
 		*(int *)data = sc->sc_outfill / hz;
 		break;
 
@@ -606,9 +645,10 @@
 }
 
 /*
- * Start output on interface.  Get another datagram
- * to send from the interface queue and map it to
- * the interface before starting output.
+ * Start output on interface.  Get another datagram to send from the
+ * interface queue and map it to the interface before starting output.  Due
+ * to IFF_NEEDSGIANT, this code runs with Giant and can safely interface
+ * with the tty code.
  */
 static int
 sltstart(struct tty *tp)
@@ -631,8 +671,11 @@
 		(*tp->t_oproc)(tp);
 
 		if (tp->t_outq.c_cc != 0) {
-			if (sc != NULL)
+			if (sc != NULL) {
+				mtx_lock(&sc->sc_mtx);
 				sc->sc_flags &= ~SC_OUTWAIT;
+				mtx_unlock(&sc->sc_mtx);
+			}
 			if (tp->t_outq.c_cc > SLIP_HIWAT)
 				return 0;
 		}
@@ -662,6 +705,7 @@
 		 * queueing, and the connection id compression will get
 		 * munged when this happens.
 		 */
+		mtx_lock(&sc->sc_mtx);
 		if (SL2IFP(sc)->if_bpf) {
 			/*
 			 * We need to save the TCP/IP header before it's
@@ -706,6 +750,7 @@
 			bcopy(mtod(m, caddr_t), &sc->bpfbuf[SLX_CHDR], CHDR_LEN);
 			BPF_TAP(SL2IFP(sc), sc->bpfbuf, len + SLIP_HDRLEN);
 		}
+		mtx_unlock(&sc->sc_mtx);
 
 		/*
 		 * If system is getting low on clists, just flush our
@@ -721,7 +766,9 @@
 			continue;
 		}
 
+		mtx_lock(&sc->sc_mtx);
 		sc->sc_flags &= ~SC_OUTWAIT;
+		mtx_unlock(&sc->sc_mtx);
 		/*
 		 * The extra FRAME_END will start up a new packet, and thus
 		 * will flush any accumulated garbage.  We do this whenever
@@ -809,6 +856,8 @@
 {
 	struct mbuf *m, *newm;
 
+	mtx_assert(&sc->sc_mtx, MA_OWNED);
+
 	MGETHDR(m, M_DONTWAIT, MT_DATA);
 	if (m == NULL)
 		return (NULL);
@@ -862,13 +911,16 @@
 	if (sc == NULL)
 		return 0;
 	if (c & TTY_ERRORMASK || (tp->t_state & TS_CONNECTED) == 0) {
+		mtx_lock(&sc->sc_mtx);
 		sc->sc_flags |= SC_ERROR;
+		mtx_unlock(&sc->sc_mtx);
 		return 0;
 	}
 	c &= TTY_CHARMASK;
 
 	++SL2IFP(sc)->if_ibytes;
 
+	mtx_lock(&sc->sc_mtx);
 	if (SL2IFP(sc)->if_flags & IFF_DEBUG) {
 		if (c == ABT_ESC) {
 			/*
@@ -887,6 +939,7 @@
 					sc->sc_starttime = time_second;
 				if (sc->sc_abortcount >= ABT_COUNT) {
 					slclose(tp,0);
+					mtx_unlock(&sc->sc_mtx);
 					return 0;
 				}
 			}
@@ -909,6 +962,7 @@
 
 	case FRAME_ESCAPE:
 		sc->sc_escape = 1;
+		mtx_unlock(&sc->sc_mtx);
 		return 0;
 
 	case FRAME_END:
@@ -993,6 +1047,7 @@
 	if (sc->sc_mp < sc->sc_ep) {
 		*sc->sc_mp++ = c;
 		sc->sc_escape = 0;
+		mtx_unlock(&sc->sc_mtx);
 		return 0;
 	}
 
@@ -1004,6 +1059,7 @@
 newpack:
 	sc->sc_mp = sc->sc_buf = sc->sc_ep - SLRMAX;
 	sc->sc_escape = 0;
+	mtx_unlock(&sc->sc_mtx);
 	return 0;
 }
 
@@ -1083,6 +1139,7 @@
 {
 	struct sl_softc *sc = chan;
 
+	mtx_lock(&sc->sc_mtx);
 	if (sc->sc_keepalive) {
 		if (sc->sc_flags & SC_KEEPALIVE) {
 			if (sc->sc_ttyp->t_pgrp != NULL) {
@@ -1096,6 +1153,7 @@
 	} else {
 		sc->sc_flags &= ~SC_KEEPALIVE;
 	}
+	mtx_unlock(&sc->sc_mtx);
 }
 
 static void
@@ -1105,6 +1163,7 @@
 	register struct tty *tp = sc->sc_ttyp;
 	int s;
 
+	mtx_lock(&sc->sc_mtx);
 	if (sc->sc_outfill && tp != NULL) {
 		if (sc->sc_flags & SC_OUTWAIT) {
 			s = splimp ();
@@ -1118,4 +1177,5 @@
 	} else {
 		sc->sc_flags &= ~SC_OUTWAIT;
 	}
+	mtx_unlock(&sc->sc_mtx);
 }
--- //depot/vendor/freebsd/src/sys/net/if_slvar.h	2005/06/10 16:51:34
+++ //depot/user/rwatson/netperf/sys/net/if_slvar.h	2005/07/05 14:55:33
@@ -34,13 +34,16 @@
 #ifndef _NET_IF_SLVAR_H_
 #define _NET_IF_SLVAR_H_
 
+#include <sys/_mutex.h>
 #include <sys/callout.h>
 
 /*
  * Definitions for SLIP interface data structures
  *
  * (This exists so programs like slstats can get at the definition
- *  of sl_softc.)
+ *  of sl_softc.)  Fields owned by the SLIP subsystem are protected
+ * using sc_mtx, with the exception of sc_next, which is protected
+ * by the global slip_mtx.
  */
 struct sl_softc {
 	struct	ifnet *sc_ifp;		/* network-visible interface */
@@ -66,6 +69,7 @@
 	struct	slcompress sc_comp;	/* tcp compression data */
 	LIST_ENTRY(sl_softc) sl_next;
 	u_char	*bpfbuf;		/* hang buffer for bpf here */
+	struct	mtx sc_mtx;
 };
 #define	SL2IFP(sc)	((sc)->sc_ifp)
 
--- //depot/vendor/freebsd/src/sys/net/if_spppsubr.c	2005/06/10 16:51:34
+++ //depot/user/rwatson/netperf/sys/net/if_spppsubr.c	2005/07/05 14:55:33
@@ -256,6 +256,9 @@
 	void	(*scr)(struct sppp *sp);
 };
 
+struct mtx sppp_mtx;
+MTX_SYSINIT(sppp_mtx, &sppp_mtx, "sppp_mtx", MTX_DEF);
+
 #if defined(__FreeBSD__) && __FreeBSD__ >= 3 && __FreeBSD_version < 501113
 #define	SPP_FMT		"%s%d: "
 #define	SPP_ARGS(ifp)	(ifp)->if_name, (ifp)->if_unit
@@ -1077,6 +1080,7 @@
 		    (ifp->if_flags & IFF_NEEDSGIANT) ? 0 : CALLOUT_MPSAFE);
 	callout_reset(&sp->keepalive_callout, hz * 10, sppp_keepalive,
  		    (void *)sp); 
+	mtx_unlock(&sppp_mtx);
 
 	ifp->if_mtu = PP_MTU;
 	ifp->if_flags = IFF_POINTOPOINT | IFF_MULTICAST;
@@ -1125,6 +1129,7 @@
 	struct sppp *sp = IFP2SP(ifp);
 	int i;
 
+	mtx_lock(&sppp_mtx);
 	KASSERT(mtx_initialized(&sp->mtx), ("sppp mutex is not initialized"));
 
 	/* Stop keepalive handler. */
@@ -4811,7 +4816,12 @@
 	struct ifnet *ifp = SP2IFP(sp);
 	int s;
 
+	/*
+	 * XXXRW: It would be nice to avoid calling all this stuff while
+	 * holding sppp_mtx, or we risk lock order reversals.
+	 */
 	s = splimp();
+	mtx_lock(&sppp_mtx);
 	SPPP_LOCK(sp);
 	/* Keepalive mode disabled or channel down? */
 	if (! (sp->pp_flags & PP_KEEPALIVE) ||
--- //depot/vendor/freebsd/src/sys/net/if_stf.c	2005/06/26 18:15:33
+++ //depot/user/rwatson/netperf/sys/net/if_stf.c	2005/07/05 14:55:33
@@ -139,14 +139,12 @@
 #define sc_ro	__sc_ro46.__sc_ro4
 	const struct encaptab *encap_cookie;
 	LIST_ENTRY(stf_softc) sc_list;	/* all stf's are linked */
+	struct mtx	sc_mtx;		/* protect sc_ro */
 };
 #define STF2IFP(sc)	((sc)->sc_ifp)
 
 /*
  * All mutable global variables in if_stf.c are protected by stf_mtx.
- * XXXRW: Note that mutable fields in the softc are not currently locked:
- * in particular, sc_ro needs to be protected from concurrent entrance
- * of stf_output().
  */
 static struct mtx stf_mtx;
 static LIST_HEAD(, stf_softc) stf_softc_list;
@@ -239,6 +237,7 @@
 		ifc_free_unit(ifc, unit);
 		return (ENOMEM);
 	}
+	mtx_init(&sc->sc_mtx, "stf sc_mtx", NULL, MTX_DEF);
 
 	ifp->if_mtu    = IPV6_MMTU;
 	ifp->if_ioctl  = stf_ioctl;
@@ -263,6 +262,7 @@
 	if_detach(STF2IFP(sc));
 	if_free(STF2IFP(sc));
 
+	mtx_destroy(&sc->sc_mtx);
 	free(sc, M_STF);
 }
 
@@ -439,9 +439,10 @@
 	struct ip6_hdr *ip6;
 	struct in6_ifaddr *ia6;
 	u_int32_t af;
-#ifdef MAC
+	struct route ro;
 	int error;
 
+#ifdef MAC
 	error = mac_check_ifnet_transmit(ifp, m);
 	if (error) {
 		m_freem(m);
@@ -540,9 +541,7 @@
 	else
 		ip_ecn_ingress(ECN_NOCARE, &ip->ip_tos, &tos);
 
-	/*
-	 * XXXRW: Locking of sc_ro required.
-	 */
+	mtx_lock(&sc->sc_mtx);
 	dst4 = (struct sockaddr_in *)&sc->sc_ro.ro_dst;
 	if (dst4->sin_family != AF_INET ||
 	    bcmp(&dst4->sin_addr, &ip->ip_dst, sizeof(ip->ip_dst)) != 0) {
@@ -561,12 +560,21 @@
 		if (sc->sc_ro.ro_rt == NULL) {
 			m_freem(m);
 			ifp->if_oerrors++;
+			mtx_unlock(&sc->sc_mtx);
 			return ENETUNREACH;
 		}
 	}
 
+	/*
+	 * XXXRW: Holding mutex over call to ip_output(): potential lock
+	 * order issue?  Hard to resolve cleanly with the current route
+	 * caching model, as we have to synchronize access to shared softc
+	 * state.
+	 */
 	ifp->if_opackets++;
-	return ip_output(m, NULL, &sc->sc_ro, 0, NULL, NULL);
+	error = ip_output(m, NULL, &ro, 0, NULL, NULL);
+	mtx_unlock(&sc->sc_mtx);
+	return (error);
 }
 
 static int
--- //depot/vendor/freebsd/src/sys/net/if_tap.c	2005/06/10 16:51:34
+++ //depot/user/rwatson/netperf/sys/net/if_tap.c	2005/07/05 14:55:33
@@ -114,6 +114,10 @@
  * All global variables in if_tap.c are locked with tapmtx, with the
  * exception of tapdebug, which is accessed unlocked; tapclones is
  * static at runtime.
+ *
+ * XXXRW: si_flags appears not to be protected from concurrent access,
+ * and is written at run-time.
+ * XXXRW: si_drv1 is also used for test-and-set, and isn't synchronized.
  */
 static struct mtx		tapmtx;
 static int			tapdebug = 0;        /* debug flag   */
@@ -172,6 +176,7 @@
 		 * The EBUSY algorithm here can't quite atomically
 		 * guarantee that this is race-free since we have to
 		 * release the tap mtx to deregister the clone handler.
+		 * XXXRW: is this true?
 		 */
 		mtx_lock(&tapmtx);
 		SLIST_FOREACH(tp, &taphead, tap_next) {
@@ -704,6 +709,7 @@
 
 		case SIOCSIFADDR:	/* set MAC address of the remote side */
 			mtx_lock(&tp->tap_mtx);
+			/* XXXRW: Does this actually do anything? */
 			bcopy(data, tp->ether_addr, sizeof(tp->ether_addr));
 			mtx_unlock(&tp->tap_mtx);
 			break;
@@ -758,6 +764,7 @@
 			if (flag & O_NONBLOCK)
 				return (EWOULDBLOCK);
 
+			/* This looks like a wanna-be condition variable. */
 			mtx_lock(&tp->tap_mtx);
 			tp->tap_flags |= TAP_RWAIT;
 			mtx_unlock(&tp->tap_mtx);
--- //depot/vendor/freebsd/src/sys/net/if_tun.c	2005/06/26 18:15:33
+++ //depot/user/rwatson/netperf/sys/net/if_tun.c	2005/07/05 14:55:33
@@ -60,6 +60,12 @@
  * tun_list is protected by global tunmtx.  Other mutable fields are
  * protected by tun->tun_mtx, or by their owning subsystem.  tun_dev is
  * static for the duration of a tunnel interface.
+ *
+ * XXXRW: we allocate si_drv1 for the dev_t on demand, rather than when
+ * the dev_t is instantiated.  Nothing serializes the test/set of that
+ * field.
+ *
+ * XXXRW: what serializes access to si_flags?
  */
 struct tun_softc {
 	TAILQ_ENTRY(tun_softc)	tun_list;
@@ -123,6 +129,9 @@
 static d_ioctl_t	tunioctl;
 static d_poll_t		tunpoll;
 
+/*
+ * XXXRW: can remove D_NEEDGIANT?  Probably not because of si_drv1 for now.
+ */
 static struct cdevsw tun_cdevsw = {
 	.d_version =	D_VERSION,
 	.d_flags =	D_PSEUDO | D_NEEDGIANT,
@@ -390,6 +399,9 @@
 	ifp->if_flags |= IFF_UP | IFF_RUNNING;
 	getmicrotime(&ifp->if_lastchange);
 
+	/*
+	 * XXXRW: interface locking.
+	 */
 	for (ifa = TAILQ_FIRST(&ifp->if_addrhead); ifa;
 	     ifa = TAILQ_NEXT(ifa, ifa_link)) {
 		if (ifa->ifa_addr == NULL)
--- //depot/vendor/freebsd/src/sys/net/if_var.h	2005/06/10 16:51:34
+++ //depot/user/rwatson/netperf/sys/net/if_var.h	2005/07/05 14:55:33
@@ -158,7 +158,8 @@
 		(void *);
 	int	(*if_resolvemulti)	/* validate/resolve multicast */
 		(struct ifnet *, struct sockaddr **, struct sockaddr *);
-	void	*if_spare1;		/* spare pointer 1 */
+	int	(*if_start_mbuf)	/* Hand off mbuf to driver for send */
+		(struct ifnet *, struct mbuf *, int);
 	void	*if_spare2;		/* spare pointer 2 */
 	void	*if_spare3;		/* spare pointer 3 */
 	u_int	if_spare_flags1;	/* spare flags 1 */
@@ -270,9 +271,12 @@
 } while (0)
 
 #define IF_DEQUEUE(ifq, m) do { 				\
-	IF_LOCK(ifq); 						\
-	_IF_DEQUEUE(ifq, m); 					\
-	IF_UNLOCK(ifq); 					\
+	if ((ifq)->ifq_head != NULL) {				\
+		IF_LOCK(ifq); 					\
+		_IF_DEQUEUE(ifq, m); 				\
+		IF_UNLOCK(ifq); 				\
+	} else							\
+		(m) = NULL;					\
 } while (0)
 
 #define	_IF_POLL(ifq, m)	((m) = (ifq)->ifq_head)
@@ -289,9 +293,11 @@
 } while (0)
 
 #define IF_DRAIN(ifq) do {					\
-	IF_LOCK(ifq);						\
-	_IF_DRAIN(ifq);						\
-	IF_UNLOCK(ifq);						\
+	if ((ifq)->ifq_head != NULL) {				\
+		IF_LOCK(ifq);					\
+		_IF_DRAIN(ifq);					\
+		IF_UNLOCK(ifq);					\
+	}							\
 } while(0)
 
 #ifdef _KERNEL
@@ -411,22 +417,11 @@
 #define	IFQ_INC_DROPS(ifq)		((ifq)->ifq_drops++)
 #define	IFQ_SET_MAXLEN(ifq, len)	((ifq)->ifq_maxlen = (len))
 
+int	ifq_handoff(struct ifnet *ifp, struct mbuf *m, int adjust);
 #define	IFQ_HANDOFF_ADJ(ifp, m, adj, err)				\
 do {									\
-	int len;							\
-	short mflags;							\
-									\
-	len = (m)->m_pkthdr.len;					\
-	mflags = (m)->m_flags;						\
-	IFQ_ENQUEUE(&(ifp)->if_snd, m, err);				\
-	if ((err) == 0) {						\
-		(ifp)->if_obytes += len + (adj);			\
-		if (mflags & M_MCAST)					\
-			(ifp)->if_omcasts++;				\
-		if (((ifp)->if_flags & IFF_OACTIVE) == 0)		\
-			if_start(ifp);					\
-	}								\
-} while (0)
+	err = ifq_handoff(ifp, m, adj);					\
+} while (0)								\
 
 #define	IFQ_HANDOFF(ifp, m, err)					\
 	IFQ_HANDOFF_ADJ(ifp, m, 0, err)
@@ -584,8 +579,10 @@
     mtx_init(&ifnet_lock, "ifnet", NULL, MTX_DEF | MTX_RECURSE)
 #define	IFNET_WLOCK()		mtx_lock(&ifnet_lock)
 #define	IFNET_WUNLOCK()		mtx_unlock(&ifnet_lock)
+#define	IFNET_WASSERT()		mtx_assert(&ifnet_lock, MA_OWNED)
 #define	IFNET_RLOCK()		IFNET_WLOCK()
 #define	IFNET_RUNLOCK()		IFNET_WUNLOCK()
+#define	IFNET_RASSERT()		IFNET_WASSERT()
 
 struct ifindex_entry {
 	struct	ifnet *ife_ifnet;
--- //depot/vendor/freebsd/src/sys/net/netisr.c	2004/10/11 20:05:57
+++ //depot/user/rwatson/netperf/sys/net/netisr.c	2004/11/28 13:01:02
@@ -1,4 +1,5 @@
 /*-
+ * Copyright (c) 2004 Robert N. M. Watson
  * Copyright (c) 2001,2002,2003 Jonathan Lemon <jlemon@FreeBSD.org>
  * Copyright (c) 1997, Stefan Esser <se@freebsd.org>
  * All rights reserved.
@@ -48,6 +49,7 @@
 #include <machine/stdarg.h>
 
 #include <sys/mbuf.h>
+#include <sys/mbufqueue.h>
 #include <sys/socket.h>
 
 #include <net/if.h>
@@ -199,11 +201,19 @@
 static struct isrstat isrstat;
 
 SYSCTL_NODE(_net, OID_AUTO, isr, CTLFLAG_RW, 0, "netisr counters");
+SYSCTL_NODE(_net_isr, OID_AUTO, dispatch, CTLFLAG_RW, 0, "direct dispatch");
+
+static int	netisr_dispatch_enable = 0;
+SYSCTL_INT(_net_isr_dispatch, OID_AUTO, enable, CTLFLAG_RW, 
+    &netisr_dispatch_enable, 0, "enable direct dispatch");
+TUNABLE_INT("net.isr.dispatch.enable", &netisr_dispatch_enable);
 
-static int	netisr_enable = 0;
-SYSCTL_INT(_net_isr, OID_AUTO, enable, CTLFLAG_RW, 
-    &netisr_enable, 0, "enable direct dispatch");
-TUNABLE_INT("net.isr.enable", &netisr_enable);
+/*
+ * XXXRW: net.isr.enable is a compatibility interface, to be removed.
+ */
+SYSCTL_INT(_net_isr, OID_AUTO, enable, CTLFLAG_RW, &netisr_dispatch_enable, 0,
+    "enable direct dispatch");
+TUNABLE_INT("net.isr.enable", &netisr_dispatch_enable);
 
 SYSCTL_INT(_net_isr, OID_AUTO, count, CTLFLAG_RD,
     &isrstat.isrs_count, 0, "");
@@ -226,14 +236,21 @@
 static void
 netisr_processqueue(struct netisr *ni)
 {
+	struct mbufqueue mbq;
+	struct ifqueue *ifq;
 	struct mbuf *m;
 
-	for (;;) {
-		IF_DEQUEUE(ni->ni_queue, m);
-		if (m == NULL)
-			break;
+	ifq = ni->ni_queue;
+	if (ifq->ifq_head == NULL)
+		return;
+	mbq_init(&mbq);
+	IF_LOCK(ifq);
+	mbq_enqueue_from_ifq(&mbq, ifq);
+	IF_UNLOCK(ifq);
+
+	while ((m = mbq_dequeue_one(&mbq)) != NULL)
 		ni->ni_handler(m);
-	}
+	mbq_assert_empty(&mbq);
 }
 
 /*
@@ -265,7 +282,7 @@
 	 * between multiple places in the system (e.g. IP
 	 * dispatched from interfaces vs. IP queued from IPSec).
 	 */
-	if (netisr_enable && (ni->ni_flags & NETISR_MPSAFE)) {
+	if (netisr_dispatch_enable && (ni->ni_flags & NETISR_MPSAFE)) {
 		isrstat.isrs_directed++;
 		/*
 		 * NB: We used to drain the queue before handling
--- //depot/vendor/freebsd/src/sys/net/raw_cb.c	2005/01/24 23:00:55
+++ //depot/user/rwatson/netperf/sys/net/raw_cb.c	2005/02/27 16:23:38
@@ -126,6 +126,7 @@
 		m_freem(dtom(rp->rcb_faddr));
 	rp->rcb_faddr = 0;
 #endif
+	/* Unlocked read. */
 	if (rp->rcb_socket->so_state & SS_NOFDREF)
 		raw_detach(rp);
 }
--- //depot/vendor/freebsd/src/sys/net/raw_usrreq.c	2005/01/07 01:52:23
+++ //depot/user/rwatson/netperf/sys/net/raw_usrreq.c	2005/02/27 16:23:38
@@ -76,6 +76,10 @@
 	register struct mbuf *m = m0;
 	struct socket *last;
 
+	/*
+	 * XXXRW: Potential lock order issues due to holding the
+	 * rawcb_mtx across all this stuff.  Need to revisit.
+	 */
 	last = 0;
 	mtx_lock(&rawcb_mtx);
 	LIST_FOREACH(rp, &rawcb_list, list) {
--- //depot/vendor/freebsd/src/sys/net/rtsock.c	2005/07/15 09:51:31
+++ //depot/user/rwatson/netperf/sys/net/rtsock.c	2005/07/19 11:47:08
@@ -54,10 +54,18 @@
 MALLOC_DEFINE(M_RTABLE, "routetbl", "routing tables");
 
 /* NB: these are not modified */
+/*
+ * XXXRW: It would be really nice to add const to these, but that may
+ * not be possible due to where they are passed in.  We might need
+ * to const-poison a whole boatload of APIs...?
+ */
 static struct	sockaddr route_dst = { 2, PF_ROUTE, };
 static struct	sockaddr route_src = { 2, PF_ROUTE, };
 static struct	sockaddr sa_zero   = { sizeof(sa_zero), AF_INET, };
 
+/*
+ * XXXRW: These fields are locked by RTSOCK_LOCK().
+ */
 static struct {
 	int	ip_count;	/* attached w/ AF_INET */
 	int	ip6_count;	/* attached w/ AF_INET6 */
--- //depot/vendor/freebsd/src/sys/netatalk/aarp.c	2005/06/10 16:51:34
+++ //depot/user/rwatson/netperf/sys/netatalk/aarp.c	2005/07/05 14:55:33
@@ -104,10 +104,6 @@
 #define AARPT_KILLC	20
 #define AARPT_KILLI	3
 
-# if !defined(__FreeBSD__)
-extern u_char			etherbroadcastaddr[6];
-# endif /* __FreeBSD__ */
-
 static const u_char atmulticastaddr[ 6 ] = {
     0x09, 0x00, 0x07, 0xff, 0xff, 0xff,
 };
@@ -119,6 +115,9 @@
     0x00, 0x00, 0x00,
 };
 
+/*
+ * XXXRW: Make use callouts, not timeouts.
+ */
 static struct callout_handle aarptimer_ch =
     CALLOUT_HANDLE_INITIALIZER(&aarptimer_ch);
 
@@ -153,6 +152,7 @@
     struct at_ifaddr	*aa;
     struct sockaddr_at	*sat2;
 
+	AT_IFADDR_LIST_LOCK();
 	for (aa = at_ifaddr_list; aa != NULL; aa = aa->aa_next) {
 		sat2 = &(aa->aa_addr);
 		if (sat2->sat_addr.s_net == sat->sat_addr.s_net) {
@@ -164,6 +164,8 @@
 			break;
 		}
 	}
+	IFAREF((struct ifaddr *)aa);
+	AT_IFADDR_LIST_UNLOCK();
 	return (aa);
 }
 
@@ -246,6 +248,7 @@
 	   ntohs(AA_SAT(aa)->sat_addr.s_net),
 	   AA_SAT(aa)->sat_addr.s_node);
 #endif /* NETATALKDEBUG */
+    IFAFREE((struct ifaddr *)aa);
 
     sa.sa_len = sizeof(struct sockaddr);
     sa.sa_family = AF_UNSPEC;
@@ -274,6 +277,7 @@
 	    bcopy(ifp->if_broadcastaddr, (caddr_t)desten,
 		    sizeof(ifp->if_addrlen));
 	}
+	IFAFREE((struct ifaddr *)aa);
 	return (1);
     }
 
@@ -383,6 +387,8 @@
 	/*
 	 * Since we don't know the net, we just look for the first
 	 * phase 1 address on the interface.
+	 *
+	 * XXXRW: Note, if_addrhead not locked here.
 	 */
 	for (aa = (struct at_ifaddr *)TAILQ_FIRST(&ifp->if_addrhead); aa;
 		aa = (struct at_ifaddr *)aa->aa_ifa.ifa_link.tqe_next) {
@@ -416,6 +422,7 @@
 	    callout_stop(&aa->aa_callout);
 	    wakeup(aa);
 	    m_freem(m);
+	    IFAFREE((struct ifaddr *)aa);
 	    return;
 	} else if (op != AARPOP_PROBE) {
 	    /*
@@ -428,6 +435,7 @@
 		    ea->aarp_sha[ 0 ], ea->aarp_sha[ 1 ], ea->aarp_sha[ 2 ],
 		    ea->aarp_sha[ 3 ], ea->aarp_sha[ 4 ], ea->aarp_sha[ 5 ]);
 	    m_freem(m);
+	    IFAFREE((struct ifaddr *)aa);
 	    return;
 	}
     }
@@ -444,6 +452,7 @@
 	    aarptfree(aat);
 	    AARPTAB_UNLOCK();
 	    m_freem(m);
+	    IFAFREE((struct ifaddr *)aa);
 	    return;
 	}
 
@@ -479,6 +488,7 @@
     if (tpa.s_net != ma.s_net || tpa.s_node != ma.s_node ||
 	    op == AARPOP_RESPONSE || (aa->aa_flags & AFA_PROBING)) {
 	m_freem(m);
+	IFAFREE((struct ifaddr *)aa);
 	return;
     }
 
@@ -497,6 +507,7 @@
 		sizeof(struct ether_aarp));
 	M_PREPEND(m, sizeof(struct llc), M_DONTWAIT);
 	if (m == NULL) {
+	    IFAFREE((struct ifaddr *)aa);
 	    return;
 	}
 	llc = mtod(m, struct llc *);
@@ -510,6 +521,7 @@
     } else {
 	eh->ether_type = htons(ETHERTYPE_AARP);
     }
+    IFAFREE((struct ifaddr *)aa);
 
     ea->aarp_tpnode = ea->aarp_spnode;
     ea->aarp_spnode = ma.s_node;
@@ -679,6 +691,9 @@
     struct aarptab	*aat;
     int			i;
 
+    /*
+     * XXXRW: Should grab mutex before untimeout?
+     */
     untimeout(aarptimer, 0, aarptimer_ch);
     AARPTAB_LOCK();
     for (i = 0, aat = aarptab; i < AARPTAB_SIZE; i++, aat++) {
--- //depot/vendor/freebsd/src/sys/netatalk/at_control.c	2005/02/22 14:20:44
+++ //depot/user/rwatson/netperf/sys/netatalk/at_control.c	2005/02/27 16:23:38
@@ -42,7 +42,15 @@
 #include <netatalk/at_var.h>
 #include <netatalk/at_extern.h>
 
+/*
+ * Access to at_ifaddr_list and the aa_next pointer in struct at_ifaddr are
+ * locked with this global mutex.
+ *
+ * XXXRW: We'll need something better in the future.
+ */
+struct mtx at_ifaddr_mtx;
 struct at_ifaddr *at_ifaddr_list;
+MTX_SYSINIT(at_ifaddr_mtx, &at_ifaddr_mtx, "at_ifaddr_mtx", MTX_DEF);
 
 static int aa_dorangeroute(struct ifaddr *ifa, u_int first, u_int last,
 	    int cmd);
@@ -74,10 +82,12 @@
 	struct at_ifaddr *aa0;
 	struct at_ifaddr *aa = NULL;
 	struct ifaddr *ifa, *ifa0;
+	int error;
 
 	/*
 	 * If we have an ifp, then find the matching at_ifaddr if it exists
 	 */
+	mtx_lock(&at_ifaddr_mtx);
 	if (ifp != NULL) {
 		for (aa = at_ifaddr_list; aa != NULL; aa = aa->aa_next) {
 			if (aa->aa_ifp == ifp)
@@ -111,16 +121,20 @@
 		 * If we a retrying to delete an addres but didn't find such,
 		 * then rewurn with an error
 		 */
-		if (cmd == SIOCDIFADDR && aa == NULL)
+		if (cmd == SIOCDIFADDR && aa == NULL) {
+			mtx_unlock(&at_ifaddr_mtx);
 			return (EADDRNOTAVAIL);
+		}
 		/*FALLTHROUGH*/
 
 	case SIOCSIFADDR:
 		/* 
 		 * If we are not superuser, then we don't get to do these ops.
 		 */
-		if (suser(td))
+		if (suser(td)) {
+			mtx_unlock(&at_ifaddr_mtx);
 			return (EPERM);
+		}
 
 		sat = satosat(&ifr->ifr_addr);
 		nr = (struct netrange *)sat->sat_zero;
@@ -148,8 +162,7 @@
 			}
 		}
 
-		if (ifp == NULL)
-			panic("at_control");
+		KASSERT(ifp != NULL, ("at_control: ifp == NULL"));
 
 		/*
 		 * If we failed to find an existing at_ifaddr entry, then we 
@@ -215,6 +228,9 @@
 			/*
 			 * If we DID find one then we clobber any routes
 			 * dependent on it..
+			 *
+			 * XXXRW: Do we really want to hold at_ifaddr_mtx
+			 * over at_scrub()?
 			 */
 			at_scrub(ifp, aa);
 		}
@@ -244,8 +260,10 @@
 			}
 		}
 
-		if (aa == NULL)
+		if (aa == NULL) {
+			mtx_unlock(&at_ifaddr_mtx);
 			return (EADDRNOTAVAIL);
+		}
 		break;
 	}
 
@@ -253,6 +271,7 @@
 	 * By the time this switch is run we should be able to assume that
 	 * the "aa" pointer is valid when needed.
 	 */
+	error = 0;
 	switch (cmd) {
 	case SIOCGIFADDR:
 
@@ -274,18 +293,30 @@
 		break;
 
 	case SIOCSIFADDR:
-		return (at_ifinit(ifp, aa,
-		    (struct sockaddr_at *)&ifr->ifr_addr));
+		/*
+		 * XXXRW: Do we really want to hold at_ifaddr_mtx over
+		 * at_ifinit().
+		 */
+		error = at_ifinit(ifp, aa,
+		    (struct sockaddr_at *)&ifr->ifr_addr);
+		break;
 
 	case SIOCAIFADDR:
 		if (sateqaddr(&ifra->ifra_addr, &aa->aa_addr))
-			return (0);
-		return (at_ifinit(ifp, aa,
-		    (struct sockaddr_at *)&ifr->ifr_addr));
+			break;
+		/*
+		 * XXXRW: Do we really want to hold at_ifaddr_mtx over
+		 * at_ifinit().
+		 */
+		error = at_ifinit(ifp, aa,
+		    (struct sockaddr_at *)&ifr->ifr_addr);
+		break;
 
 	case SIOCDIFADDR:
 		/*
 		 * scrub all routes.. didn't we just DO this? XXX yes, del it
+		 *
+		 * XXXRW: Do we want to hold at_ifaddr_mtx over at_scrub()?
 		 */
 		at_scrub(ifp, aa);
 
@@ -309,10 +340,9 @@
 			/*
 			 * if we found it, remove it, otherwise we screwed up.
 			 */
-			if (aa->aa_next)
-				aa->aa_next = aa0->aa_next;
-			else
-				panic("at_control");
+			KASSERT(aa->aa_next != NULL,
+			    ("at_control: aa->aa_next == NULL"));
+			aa->aa_next = aa0->aa_next;
 		}
 
 		/*
@@ -322,11 +352,14 @@
 		break;
 
 	default:
-		if (ifp == NULL || ifp->if_ioctl == NULL)
-			return (EOPNOTSUPP);
-		return ((*ifp->if_ioctl)(ifp, cmd, data));
+		if (ifp == NULL || ifp->if_ioctl == NULL) {
+			error = EOPNOTSUPP;
+			break;
+		}
+		error = (*ifp->if_ioctl)(ifp, cmd, data);
 	}
-	return (0);
+	mtx_unlock(&at_ifaddr_mtx);
+	return (error);
 }
 
 /* 
@@ -340,6 +373,14 @@
 {
 	int error;
 
+	/*
+	 * XXXRW: We don't asser the at_ifaddr_mtx here, but we do rely on
+	 * the caller holding a reference to 'aa' in such a way that it won't
+	 * go away as at_scrub() runs.  In practice this means that either
+	 * the caller has to hold an ifaddr reference or at_ifaddr_mtx.
+	 *
+	 * mtx_assert(&at_ifaddr_mtx, MA_OWNED);
+	 */
 	if (aa->aa_flags & AFA_ROUTE) {
 		if (ifp->if_flags & IFF_LOOPBACK) {
 			if ((error = aa_delsingleroute(&aa->aa_ifa,
@@ -374,6 +415,7 @@
 	int netinc, nodeinc, nnets;
 	u_short net;
 
+	mtx_assert(&at_ifaddr_mtx, MA_OWNED);
 	/* 
 	 * save the old addresses in the at_ifaddr just in case we need them.
 	 */
@@ -517,13 +559,15 @@
 				/*
 				 * start off the probes as an asynchronous
 				 * activity.  though why wait 200mSec?
+				 *
+				 * XXXRW: This probably opens up a race, but
+				 * the race already existed it and so I
+				 * haven't fixed it.
 				 */
-				AARPTAB_LOCK();
 				callout_reset(&aa->aa_callout, hz / 5,
 				    aarpprobe, ifp);
-				if (msleep(aa, &aarptab_mtx, PPAUSE|PCATCH,
+				if (msleep(aa, &at_ifaddr_mtx, PPAUSE|PCATCH,
 				    "at_ifinit", 0)) {
-					AARPTAB_UNLOCK();
 					/*
 					 * theoretically we shouldn't time
 					 * out here so if we returned with an
@@ -536,7 +580,6 @@
 					aa->aa_lastnet = onr.nr_lastnet;
 					return (EINTR);
 				}
-				AARPTAB_UNLOCK();
 
 				/* 
 				 * The async activity should have woken us
@@ -572,6 +615,9 @@
 	/* 
 	 * Now that we have selected an address, we need to tell the interface
 	 * about it, just in case it needs to adjust something.
+	 *
+	 * XXXRW: Should we release at_ifaddr_mtx before calling into the
+	 * interface ioctl() code?
 	 */
 	if (ifp->if_ioctl != NULL &&
 	    (error = (*ifp->if_ioctl)(ifp, SIOCSIFADDR, (caddr_t)aa))) {
@@ -644,6 +690,10 @@
 	 * getting risky by now XXX
 	 */
 	if (error) {
+		/*
+		 * XXXRW: Do we want to hold at_ifaddr_mtx over calls to
+		 * at_scrub()?
+		 */
 		at_scrub(ifp, aa);
 		aa->aa_addr = oldaddr;
 		aa->aa_firstnet = onr.nr_firstnet;
@@ -666,6 +716,7 @@
 at_broadcast(struct sockaddr_at *sat)
 {
 	struct at_ifaddr *aa;
+	int ret;
 
 	/*
 	 * If the node is not right, it can't be a broadcast 
@@ -682,13 +733,18 @@
 	/*
 	 * failing that, if the net is one we have, it's a broadcast as well.
 	 */
+	ret = 0;
+	mtx_lock(&at_ifaddr_mtx);
 	for (aa = at_ifaddr_list; aa != NULL; aa = aa->aa_next) {
 		if ((aa->aa_ifp->if_flags & IFF_BROADCAST)
 		    && (ntohs(sat->sat_addr.s_net) >= ntohs(aa->aa_firstnet)
-		    && ntohs(sat->sat_addr.s_net) <= ntohs(aa->aa_lastnet)))
-			return (1);
+		    && ntohs(sat->sat_addr.s_net) <= ntohs(aa->aa_lastnet))) {
+			ret = 1;
+			break;
+		}
 	}
-	return (0);
+	mtx_unlock(&at_ifaddr_mtx);
+	return (ret);
 }
 
 /*
@@ -810,6 +866,10 @@
 	struct ifaddr *ifa;
 	struct ifnet *ifp;
 
+	/*
+	 * XXXRW: #if 0, and hence untested.
+	 */
+	mtx_lock(&at_ifaddr_mtx);
 	while ((aa = at_ifaddr_list) != NULL) {
 		ifp = aa->aa_ifp;
 		at_scrub(ifp, aa);
@@ -820,13 +880,12 @@
 			while (ifa->ifa_next &&
 			    (ifa->ifa_next != (struct ifaddr *)aa))
 				ifa = ifa->ifa_next;
-			if (ifa->ifa_next)
-				ifa->ifa_next =
-				    ((struct ifaddr *)aa)->ifa_next;
-			else
-				panic("at_entry");
+			KASSERT(ifa->ifa_next != NULL,
+			    ("aa_clean: ifa_next == NULL"));
+			ifa->ifa_next = ((struct ifaddr *)aa)->ifa_next;
 		}
 	}
+	mtx_unlock(&at_ifaddr_mtx);
 }
 
 #endif
--- //depot/vendor/freebsd/src/sys/netatalk/at_var.h	2005/02/22 14:20:44
+++ //depot/user/rwatson/netperf/sys/netatalk/at_var.h	2005/02/27 16:23:38
@@ -60,6 +60,11 @@
 #define AFA_PHASE2	0x0004
 
 #ifdef _KERNEL
+extern struct mtx at_ifaddr_mtx;
+#define	AT_IFADDR_LIST_ASSERT()	mtx_assert(&at_ifaddr_mtx, MA_OWNED)
+#define	AT_IFADDR_LIST_LOCK()	mtx_lock(&at_ifaddr_mtx)
+#define	AT_IFADDR_LIST_UNLOCK()	mtx_unlock(&at_ifaddr_mtx)
+
 extern struct at_ifaddr	*at_ifaddr_list;
 #endif
 
